<script setup lang="ts">
  import { ClientApiError, CustomerAddress, ShopwareError, Salutation } from '@shopware-pwa/types';
  import CheckoutRegister from '@/components/checkout/CheckoutRegister.vue';
  import AccountAddressForm from '@/components/account/AccountAddressForm.vue';
  import { SALUTATION_DEFAULT } from '~/helpers/constants';
  import { ShopPage } from '~/logic/interfaces';

  definePageMeta({
    middleware: ['user-pre-action'],
  });

  const { t } = useI18n();
  const { push } = useRouter();
  const { createToast } = useToasts();
  const { paymentMethods, shippingMethods, getPaymentMethods, getShippingMethods, createOrder } =
    useCheckout();
  const { getSalutations } = useSalutations();
  const { logout, isLoggedIn, isGuestSession, user, register } = useUser();
  const {
    refreshSessionContext,
    selectedShippingMethod: shippingMethod,
    selectedPaymentMethod: paymentMethod,
    setShippingMethod,
    setPaymentMethod,
    activeShippingAddress,
    setActiveShippingAddress,
    setActiveBillingAddress,
    sessionContext,
  } = useSessionContext();
  const { cart, cartItems, isVirtualCart, refreshCart, hasVirtualCartItem } = useCart();
  const { customerAddresses, loadCustomerAddresses, createCustomerAddress, updateCustomerAddress } =
    useAddress();
  const { openShopPage } = useShopPage();

  const isLoading = reactive({
    shippingAddresses: false,
    shippingMethods: false,
    paymentMethods: false,
    placeOrder: false,
  });

  const isUpdating = reactive({
    shippingAddressId: '',
    billingAddressId: '',
    shippingMethodId: '',
    paymentMethodId: '',
  });

  const customShipping = ref(false);
  const selectedAddress = ref();

  const selectedShippingMethod = computed({
    get: (): string => {
      return shippingMethod.value?.id || '';
    },
    set: async (shippingMethodId: string): Promise<void> => {
      isUpdating.shippingMethodId = shippingMethodId;
      await setShippingMethod({ id: shippingMethodId });
      isUpdating.shippingMethodId = '';
    },
  });

  const selectedPaymentMethod = computed({
    get: (): string => {
      return paymentMethod.value?.id || '';
    },
    set: async (paymentMethodId: string): Promise<void> => {
      isUpdating.paymentMethodId = paymentMethodId;
      await setPaymentMethod({ id: paymentMethodId });
      isUpdating.paymentMethodId = '';
    },
  });

  const selectedShippingAddress = computed({
    get: (): string => {
      return activeShippingAddress.value?.id || '';
    },
    set: async (shippingAddressId: string): Promise<void> => {
      try {
        isUpdating.shippingAddressId = shippingAddressId;
        await setActiveShippingAddress({ id: shippingAddressId });
        await handleAccountUpdated();

        createToast({
          content: t('account.messages.changeShippingAddressSuccessfully'),
          variant: 'success',
        });
      } catch (error) {
        createToast({
          content: t('account.messages.changeShippingAddressError'),
          variant: 'error',
        });
      } finally {
        if (shippingAddressId === selectedBillingAddress.value) customShipping.value = false;
        isUpdating.shippingAddressId = '';
      }
    },
  });

  const activeBillingAddress = computed(() => {
    return sessionContext.value?.customer?.activeBillingAddress || null;
  });

  const selectedBillingAddress = computed({
    get: (): string => {
      return activeBillingAddress.value?.id || '';
    },
    set: async (billingAddressId: string): Promise<void> => {
      try {
        isUpdating.billingAddressId = billingAddressId;
        await setActiveBillingAddress({ id: billingAddressId });
        await handleAccountUpdated();
        createToast({
          content: t('account.messages.changeBillingAddressSuccessfully'),
          variant: 'success',
        });
      } catch (error) {
        createToast({
          content: t('account.messages.changeBillingAddressError'),
          variant: 'error',
        });
      } finally {
        if (billingAddressId === selectedShippingAddress.value) customShipping.value = false;
        isUpdating.billingAddressId = '';
      }
    },
  });

  const isCartLoading = computed(() => {
    return !cart.value;
  });

  const isCheckoutAvailable = computed(() => {
    return cartItems.value.length > 0;
  });

  const isUserSession = computed(() => isLoggedIn.value || isGuestSession.value);

  const terms = reactive({
    tos: false,
    revocation: false,
  });

  const termsBox = ref();
  const registerErrors = ref<ShopwareError[]>([]);
  const checkoutErrors = ref<ShopwareError[]>([]);

  const accountAddressesModalController = useModal();
  const accountAddressUpsertModalController = useModal();
  const accountAddressesModalType: Ref<'shipping' | 'billing'> = ref('shipping');
  const checkoutRegisterRef = ref<InstanceType<typeof CheckoutRegister>>();
  const billingAddressRef = ref<InstanceType<typeof AccountAddressForm>>();

  const termsSelected = computed(() => {
    return terms.tos && (isVirtualCart.value ? terms.revocation : true);
  });

  const placeOrderTriggered = ref(false);

  const handleAccountUpdated = async () => {
    isLoading.shippingAddresses = true;
    isLoading.shippingMethods = true;
    isLoading.paymentMethods = true;

    await Promise.all([
      loadCustomerAddresses(),
      !isVirtualCart.value ? getShippingMethods() : null,
      refreshCart(),
      getPaymentMethods(),
    ]).finally(() => {
      isLoading.shippingAddresses = false;
      isLoading.shippingMethods = false;
      isLoading.paymentMethods = false;
    });
  };

  onMounted(async () => {
    await refreshSessionContext();

    isLoading.shippingAddresses = true;
    isLoading.shippingMethods = true;
    isLoading.paymentMethods = true;

    await Promise.all([
      isLoggedIn.value || isGuestSession.value ? loadCustomerAddresses() : null,
      !isVirtualCart.value ? getShippingMethods() : null,
      !cart.value ? refreshCart() : null,
      getPaymentMethods(),
    ]).finally(() => {
      isLoading.shippingAddresses = false;
      isLoading.shippingMethods = false;
      isLoading.paymentMethods = false;
    });
  });

  const invokeLogout = async () => {
    await logout();
    await push('/');
  };

  const updateShippingMethod = (id: string) => {
    selectedShippingMethod.value = id;
  };

  const updatePaymentMethod = (id: string) => {
    selectedPaymentMethod.value = id;
  };

  const openShippingAddressesModal = () => {
    accountAddressesModalType.value = 'shipping';
    accountAddressesModalController.open();
  };

  const openBillingAddressesModal = () => {
    accountAddressesModalType.value = 'billing';
    accountAddressesModalController.open();
  };

  const preCreateAddress = () => {
    accountAddressesModalController.close();
    selectedAddress.value = undefined;
    accountAddressUpsertModalController.open();
  };

  const preEditAddress = (id: string) => {
    accountAddressesModalController.close();
    selectedAddress.value = customerAddresses.value.find((el) => el.id === id);
    accountAddressUpsertModalController.open();
  };

  const setAddress = (id: string) => {
    if (accountAddressesModalType.value === 'shipping') {
      selectedShippingAddress.value = id;
    } else {
      selectedBillingAddress.value = id;
    }

    accountAddressesModalController.close();
  };

  const saveAddress = async (payload: CustomerAddress) => {
    const saveAddress = payload.id ? updateCustomerAddress : createCustomerAddress;

    const address = await saveAddress(payload);

    if (accountAddressesModalType.value === 'shipping') {
      selectedShippingAddress.value = address.id;
    } else {
      selectedBillingAddress.value = address.id;
    }

    accountAddressUpsertModalController.close();
  };

  const handleCloseAccountAddressUpsertModal = () => {
    accountAddressUpsertModalController.close();
    accountAddressesModalController.open();
  };

  const handleForgotPassword = () => {
    accountLoginModalController.close();
    accountForgotPasswordModalController.open();
  };

  const handleBackToLoginModal = () => {
    accountForgotPasswordModalController.close();
    accountLoginModalController.open();
  };

  const registerSubmit = async () => {
    try {
      isLoading.placeOrder = true;
      registerErrors.value = [];

      const isUserValid = await checkoutRegisterRef.value?.validate();
      const isAddressValid = await billingAddressRef.value?.validate();

      if (isUserValid && isAddressValid) {
        const { firstName, lastName, street, zipcode, city, countryId, countryStateId } =
          billingAddressRef?.value?.state as CustomerAddress;
        const { email, password, isCreateNewAccount } = checkoutRegisterRef.value!.state;
        const salutation =
          getSalutations.value.findLast(
            (salutation: Salutation) => salutation.salutationKey === SALUTATION_DEFAULT,
          ) || getSalutations.value[0];

        const payload = {
          email,
          password,
          guest: !isCreateNewAccount,
          salutationId: salutation.id,
          firstName,
          lastName,
          billingAddress: {
            street,
            zipcode,
            city,
            countryId,
            countryStateId,
          },
        };

        await register(payload);
        await handleAccountUpdated();
      }
    } catch (error) {
      const e = error as ClientApiError;
      registerErrors.value = e.messages;
    } finally {
      isLoading.placeOrder = false;
    }
  };

  const placeOrder = async () => {
    placeOrderTriggered.value = true;
    checkoutErrors.value = [];

    if (!termsSelected.value) {
      termsBox.value.scrollIntoView();
      return;
    }

    try {
      isLoading.placeOrder = true;
      const order = await createOrder();
      push('/checkout/success/' + order.id);
    } catch (error) {
      const e = error as ClientApiError;
      checkoutErrors.value = e.messages;
    } finally {
      isLoading.placeOrder = false;
    }
  };

  const handleSubmitButton = async () => {
    if (!isUserSession.value) {
      await registerSubmit();
    }
    await placeOrder();
  };
  const accountForgotPasswordModalController = useModal();
  const accountLoginModalController = useModal();
</script>

<template>
  <div class="mx-auto p-4 md:max-w-[70rem] md:px-0 md:py-12">
    <div
      v-if="isCheckoutAvailable || isCartLoading"
      :class="{
        'opacity-20': isCartLoading,
      }"
    >
      <div class="flex flex-col flex-wrap space-y-10 md:flex-row md:space-x-20 md:space-y-0">
        <div class="flex flex-1 flex-col space-y-10 md:space-y-12">
          <!-- Account section -->
          <div class="flex flex-col pt-6">
            <h1 class="text-[1.75rem]/8">{{ $t('account.account') }}</h1>
            <!-- Account does not log in -->
            <div v-if="checkoutErrors?.length" class="mt-3">
              <SwBanner
                v-for="error in checkoutErrors"
                :key="error.detail"
                class="my-3"
                variant="error"
                :show-close-btn="false"
              >
                {{ error.detail }}
              </SwBanner>
            </div>
            <div v-if="!isUserSession">
              <CheckoutRegister
                ref="checkoutRegisterRef"
                :register-errors="registerErrors"
                @open-login-modal="accountLoginModalController.open"
              />
              <!-- Billing Address section -->
              <h2 class="pb-6 pt-10 text-xl font-bold">{{ $t('checkout.billingAddressLabel') }}</h2>
              <AccountAddressForm ref="billingAddressRef" />
            </div>

            <!-- Account logged in -->
            <div
              v-else-if="user"
              class="bg-background-raised text-(sm/6 information) mt-6 flex justify-between rounded-md px-4 py-3.5 font-medium"
            >
              <div v-if="isGuestSession">
                {{ $t('checkout.loggedInAs') }}
                <span class="font-semibold"
                  >{{ user.firstName }} {{ user.lastName }} ({{ $t('checkout.guest') }})</span
                >
              </div>
              <div v-else>
                {{ $t('checkout.loggedInAs') }}
                <span class="font-semibold">{{ user.firstName }} {{ user.lastName }}</span>
              </div>
              <SwLink @click="invokeLogout">{{ $t('account.logOut') }}</SwLink>
            </div>
          </div>
          <!-- Shipping section -->
          <section v-if="!isVirtualCart">
            <div class="pb-6 text-xl font-bold md:text-[1.75rem]/8">{{ $t('shipping') }}</div>

            <!-- confirming -->
            <!-- <SwCheckbox v-model="customShipping">
              <template #label>
                <span>
                  {{ $t('checkout.differentShippingAddress') }}
                </span>
              </template>
            </SwCheckbox> -->

            <CheckoutShippingMethods
              :model-value="selectedShippingMethod"
              :loading="isLoading.shippingMethods"
              :updating-id="isUpdating.shippingMethodId"
              :options="shippingMethods"
              @update:model-value="updateShippingMethod"
            >
              <div
                v-if="isUserSession && activeShippingAddress"
                class="bg-background-raised mb-6 flex flex-col items-start gap-2 rounded-md p-4"
              >
                <p class="font-bold">{{ $t('checkout.shippingAddressLabel') }}</p>

                <AccountAddressDetail
                  :address="activeShippingAddress"
                  :updating-id="isUpdating.shippingAddressId"
                />

                <SwButton
                  variant="action"
                  size="small"
                  class="font-medium"
                  :disabled="!!isUpdating.shippingAddressId"
                  @click="openShippingAddressesModal"
                  >{{ $t('change') }}</SwButton
                >
              </div>
            </CheckoutShippingMethods>
          </section>

          <!-- Payment section -->
          <section>
            <div class="pb-6 text-xl font-bold md:text-[1.75rem]/8">{{ $t('payment') }}</div>

            <CheckoutPaymentMethods
              :model-value="selectedPaymentMethod"
              :loading="isLoading.paymentMethods"
              :updating-id="isUpdating.paymentMethodId"
              :options="paymentMethods"
              @update:model-value="updatePaymentMethod"
            >
              <div
                v-if="isUserSession"
                class="bg-background-raised mb-6 flex flex-col items-start gap-2 rounded-md p-4"
              >
                <p class="font-bold">{{ $t('checkout.billingAddressLabel') }}</p>

                <p
                  v-if="selectedShippingAddress === selectedBillingAddress"
                  class="text-sm/6 font-medium"
                >
                  {{ $t('checkout.sameAsShippingAddress') }}
                </p>

                <AccountAddressDetail
                  v-else
                  :address="activeBillingAddress"
                  :updating-id="isUpdating.billingAddressId"
                />

                <SwButton
                  variant="action"
                  size="small"
                  class="font-medium"
                  :disabled="!!isUpdating.billingAddressId"
                  @click="openBillingAddressesModal"
                  >{{ $t('change') }}</SwButton
                >
              </div>
            </CheckoutPaymentMethods>
          </section>
        </div>
        <!-- Summary section -->
        <div class="md:(w-[30rem]) flex-none">
          <CheckoutSummary />
        </div>
      </div>
      <!-- Place oder section -->
      <div class="flex flex-row md:space-x-20">
        <div class="flex flex-1 flex-col pt-10 md:pt-12">
          <fieldset ref="termsBox" class="flex flex-col space-y-3">
            <SwCheckbox v-model="terms.tos">
              <template #label>
                <span :class="{ 'text-danger': !termsSelected && placeOrderTriggered }">
                  <i18n-t keypath="checkout.termsAndConditionsLabel" :tag="false">
                    <template #termsAndConditions>
                      <SwLink
                        :class="{ '!text-danger': !termsSelected && placeOrderTriggered }"
                        @click="openShopPage(ShopPage.GTC)"
                      >
                        {{ $t('checkout.termsAndConditions') }}
                      </SwLink>
                    </template>
                  </i18n-t>
                </span>
              </template>
            </SwCheckbox>

            <SwCheckbox v-if="hasVirtualCartItem" v-model="terms.revocation">
              <template #label>
                <span :class="{ 'text-danger': !termsSelected && placeOrderTriggered }">
                  {{ $t('checkout.digitalTerms') }}
                </span>
              </template>
            </SwCheckbox>
          </fieldset>
          <SwButton
            type="button"
            size="large"
            class="mt-6"
            :loading="isLoading.placeOrder"
            @click="handleSubmitButton"
          >
            {{ $t('checkout.payAndSubmitOrder') }}
          </SwButton>
          <span class="pt-3 text-sm/6">
            {{ $t('checkout.pleaseNoteOur') }}
            <SwLink @click="openShopPage(ShopPage.REVOCATION)">
              {{ $t('checkout.cancellationPolicy') }}</SwLink
            >
          </span>
        </div>
        <div class="hidden w-[30rem] flex-none md:block" />
      </div>
    </div>
    <!-- TODO: Empty cart state, waiting for design -->
    <div v-else class="text-center">
      <h1 class="m-10 text-2xl font-medium">{{ $t('cart.emptyCartLabel') }}</h1>
    </div>
  </div>

  <AccountAddressesModal
    v-if="accountAddressesModalController.isOpen.value"
    :controller="accountAddressesModalController"
    :type="accountAddressesModalType"
    :addresses="customerAddresses"
    :current-address="
      accountAddressesModalType === 'shipping' ? activeShippingAddress : activeBillingAddress
    "
    @create="preCreateAddress"
    @edit="preEditAddress"
    @set-address="setAddress"
  />

  <AccountAddressUpsertModal
    v-if="accountAddressUpsertModalController.isOpen.value"
    :controller="accountAddressUpsertModalController"
    :address="selectedAddress"
    @save="saveAddress"
    @close="handleCloseAccountAddressUpsertModal"
  />

  <AccountLoginForm
    v-if="accountLoginModalController.isOpen.value"
    :controller="accountLoginModalController"
    @success="handleAccountUpdated"
    @forgot-password="handleForgotPassword"
  />

  <AccountForgotPasswordModal
    v-if="accountForgotPasswordModalController.isOpen.value"
    :controller="accountForgotPasswordModalController"
    @back-to-login="handleBackToLoginModal"
  />
</template>
